#include <stdio.h>
#include <stdlib.h>
#include "thread/h/thread.h"

static thread_t tmain, treader, twriter;

#define RW_READY (MSG_TAG_USER+1)
#define RW_TAG   (MSG_TAG_USER+2)

static void* reader(void* junk) {
	unsigned i;
	thread_t tid = THR_TID_UNSPEC;
    tag_t tag;

    msg_send(tmain, RW_READY, 0, 0); // send ready to main
    tag = RW_READY;
    msg_recv(&tid, &tag, 0, 0); // sync with main
    for (i = 0; i < 10; ++i) {
        unsigned msg, size;
        tag  = RW_TAG;
        size = sizeof msg;
		tid = THR_TID_UNSPEC;
        msg_recv(&tid, &tag, &msg, &size);
        thr_do_trace("msg=%u", msg); // receive and print message
    }
    return 0;
}

static void* writer(void* junk) {
	unsigned i;
	thread_t tid = THR_TID_UNSPEC;
    tag_t tag;

    msg_send(tmain, RW_READY, 0, 0); // send ready to main
    tag = RW_READY;
    msg_recv(&tid, &tag, 0, 0); // synch with main
    for (i = 0; i < 10; ++i) {
        msg_send(treader, RW_TAG, &i, sizeof i); // send message
    }
    return 0;
}

int main() {
    tag_t tag;

    tmain = thr_self();

    thr_create(0, 0, reader, 0, 0, &treader); // create reader
    thr_create(0, 0, writer, 0, 0, &twriter); // create writer

    tag = RW_READY; msg_recv(&treader, &tag, 0, 0); // wait for reader
    tag = RW_READY; msg_recv(&twriter, &tag, 0, 0); // and writer
    msg_send(treader, RW_READY, 0, 0); // release reader
    msg_send(twriter, RW_READY, 0, 0); // and writer

    thr_join(0, 0, 0);
    thr_join(0, 0, 0);

    return 0;
}
